<?php
namespace Repository;

use Util\Instance\GeneralProvider as InstanceProvider;
use Util\Utilities;
use Doctrine\ORM\EntityManager;


class Objects
{

    /** @var EntityManager **/
    protected $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function getObjectsBody($objectName, $objectType)
    {
        $query = <<<SQL
               SELECT TRIM(TRIM(CHR(10) FROM REPLACE(REPLACE(REPLACE(SQL, '"' || :OWNER || '".', ''), 'FORCE EDITIONABLE ', ''), 'EDITIONABLE ', ''))) AS SQL
                 FROM (SELECT SUBSTR(SQL, 1, CASE WHEN INSTR(SQL, CHR(10) || '/', -1) > 0
                                                  THEN INSTR(SQL, CHR(10) || '/', -1) - 1
                                                  WHEN INSTR(SQL, 'ALTER ' || :OBJECT_TYPE, -1) > 0
                                                  THEN INSTR(SQL, 'ALTER ' || :OBJECT_TYPE, -1) - 1
                                                  ELSE LENGTH(SQL)
                                              END) AS SQL
                         FROM (SELECT DBMS_METADATA.GET_DDL(:OBJECT_TYPE, :OBJECT_NAME, :OWNER) AS SQL
                                 FROM DUAL))
SQL;
        $params = array(
            'OBJECT_NAME' => $objectName,
            'OBJECT_TYPE' => $objectType,
            'OWNER'       => Utilities::getOwner()
        );
        return Utilities::getReferenceConnection()->fetchAll($query, $params);
    }
    public function findObjectsObservation($objectName, $objectType)
    {
        $query = <<<SQL
               SELECT DSOBJETO FROM OBJETO
                WHERE NMOBJETO = :OBJECT_NAME
                  AND IDTPOBJETO = :OBJECT_TYPE
SQL;
        $params = array(
            'OBJECT_NAME' => $objectName,
            'OBJECT_TYPE' => $objectType
        );
        return $this->entityManager->getConnection()->fetchAll($query, $params);

    }

}