<?php
namespace Repository;

use Util\Instance\GeneralProvider as InstanceProvider;
use Util\Utilities;

class Repositorio
{

    public function getAllRepositories($conditions, $currentUser, $limit, $offset)
    {
        $query = <<<SQL
                  SELECT *
                  FROM ( SELECT MRE.ID, MRE.NMREPOSITORIO, MRE.DSURLREPOSITORIO, MRO.ID AS D_ID,
                                MRO.REPOSITORIO_ID, MRO.DSDIRREPOSITORIO, MRE.IDATIVO
                           FROM MT_REPOSITORIO MRE
                      LEFT JOIN MT_REPOSITORIO_OPERADOR MRO ON MRE.ID = MRO.REPOSITORIO_ID
                                                           AND MRO.CDOPERADOR = :CDOPER)
                  WHERE 1=1
                  $conditions
                  ORDER BY ID

SQL;
        $params = array(
            'CDOPER' => $currentUser,
        );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function validateRepositorioDelete($repositorio, $usuario)
    {
        $query = <<<SQL
                  SELECT ID
                    FROM MT_REPOSITORIO_OPERADOR
                   WHERE REPOSITORIO_ID = :REPOSITORIO
                     AND CDOPERADOR != :USUARIO

SQL;
        $params = array(
            'REPOSITORIO' => $repositorio,
            'USUARIO' => $usuario
        );
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function validateStructureDesign($repositorio)
    {
        $query = <<<SQL
                      SELECT ID
                        FROM MT_DESIGN_ESTRUTURA
                      WHERE REPOSITORIO_ID = :REPOSITORIO

SQL;
        $params = array(
            'REPOSITORIO' => $repositorio
        );
        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function validateWebSocketDirectory($cdoperador, $idrepositorio)
    {
        $query = <<<SQL
                    SELECT DSDIRREPOSITORIO
                      FROM ( SELECT MRE.ID, MRO.DSDIRREPOSITORIO, MRE.IDATIVO
                               FROM MT_REPOSITORIO MRE
                          LEFT JOIN MT_REPOSITORIO_OPERADOR MRO ON MRE.ID = MRO.REPOSITORIO_ID
                                                               AND MRO.CDOPERADOR = :CDOPER
                              WHERE MRE.ID = :IDREP
                                AND MRE.IDATIVO = 'S')
                     WHERE 1=1

SQL;
        $params = array(
            'CDOPER' => $cdoperador,
            'IDREP' => $idrepositorio
        );

        return InstanceProvider::getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}