CREATE OR REPLACE PROCEDURE ARQITENS_MERSERV_434(
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_NRINSJURFILI IN FILIAL.NRINSJURFILI%TYPE,
   P_CDIMPOSTO    IN IMPOSTONF.CDIMPOSTO%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_NATU            VARCHAR(50);
   V_SEQ_NATU        NUMBER;
   V_PROD            VARCHAR(50);
   V_SEQ_PROD        NUMBER;
   V_SEQUNCIAL       NUMBER;
   V_CDFISCALIT      VARCHAR(02);
   V_CDSITUTRIBITNFE VARCHAR(02);
BEGIN

   V_SEQ_NATU := 0;
   V_SEQ_PROD := 0;

   SELECT NVL(MAX(CDCONTREGI),0)
     INTO V_SEQ_NATU
     FROM TMP_REGDADOS_IN86
    WHERE CDREGISTRO = '494';

   SELECT NVL(MAX(CDCONTREGI),0)
     INTO V_SEQ_PROD
     FROM TMP_REGDADOS_IN86
    WHERE CDREGISTRO = '495';

   FOR C_TMP IN (SELECT CDREGISTRO, CDCHAVEREG, CDCAMPO1
                   FROM TMP_REGDADOS_IN86
                  WHERE CDREGISTRO = '433' ) LOOP

       FOR C_ARQITENS_MERSERV IN (SELECT  C_TMP.CDCAMPO1                                                     || /*INICIO REG.433*/
                                          SUBSTR(LPAD(IT.NRSEQITPROD, 4, 0), 2, 3)                           ||
                                          RPAD(PR.CDPRODUTO, 20, ' ')                                        ||
                                          RPAD(' ', 45, ' ')                                                 ||
                                          RPAD(NVL(IT.CDFISOPEITEM, ' '), 4, ' ')                            ||
                                          RPAD(NVL(IT.CDFISOPEITEM, ' '), 6, ' ')                            ||
                                          RPAD(NVL(NVL(IT.CDPRODNCMTRANS,PR.CDCLASFISC), ' '), 8, ' ')                              ||
                                          LPAD(NVL(SUBSTR(ROUND(IT.QTITEMPROD,2) * 1000, 1, 17), 0), 17, 0)  ||
                                          RPAD(NVL(PR.SGUNIDADE, ' '), 3, ' ')                               ||
                                          LPAD(NVL(SUBSTR(ROUND(IT.VRUNITITEM,2) * 10000, 1, 17), 0), 17, 0) ||
                                          LPAD(NVL(SUBSTR(ROUND(IT.VRTOTAITEM,2) * 100, 1, 17), 0), 17, 0)   ||
                                          LPAD(NVL(SUBSTR(ROUND(IT.VRDESCITEM,2) * 100, 1, 17), 0), 17, 0)   AS PART1,
                                          LPAD(NVL(SUBSTR(ROUND(VALOR_IMPOSTO_ITEM_NFE(II.CDFILIAL,II.NRLANCTONF,II.NRSEQITPROD,'10','A','1'),2)*100,1,5),0),5,0)||
                                          LPAD(NVL(SUBSTR(ROUND(VALOR_IMPOSTO_ITEM_NFE(II.CDFILIAL,II.NRLANCTONF,II.NRSEQITPROD,'10','B','1'),2)*100,1,17),0),17,0)||
                                          LPAD(NVL(SUBSTR(ROUND(VALOR_IMPOSTO_ITEM_NFE(II.CDFILIAL,II.NRLANCTONF,II.NRSEQITPROD,'10','I','1'),2)*100,1,17),0),17,0)||
                                          RPAD(NVL(IT.CDSITUTRIBPR, ' '),3, ' ')                                  ||
                                          RPAD(NVL(II.CDFISCALIT, '3'), 1, ' ')                                   ||
                                          LPAD(NVL(SUBSTR(ROUND(II.VRALIQITEM,2) * 100, 1, 5), 0), 5, 0)          ||
                                          LPAD(NVL(SUBSTR(ROUND(II.VRBASECALCIT,2) * 100, 1, 17), 0), 17, 0) ||
                                          LPAD(NVL(SUBSTR(ROUND(II.VRIMPOSTOIT,2) * 100, 1, 17), 0), 17, 0)  ||
                                          LPAD(NVL(SUBSTR(ROUND(VALOR_IMPOSTO_ITEM_NFE(II.CDFILIAL,II.NRLANCTONF,II.NRSEQITPROD,'80','B','1'),2)*100,1,17),0),17,0)||
                                          LPAD(NVL(SUBSTR(ROUND(VALOR_IMPOSTO_ITEM_NFE(II.CDFILIAL,II.NRLANCTONF,II.NRSEQITPROD,'80','I','1'),2)*100,1,17),0),17,0)||
                                          'S' AS PART2,
                                          IT.CDFISOPEITEM, PR.CDPRODUTO, IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD
                                     FROM ITEMPRODUTO IT, PRODUTO PR, ITEMPROIMPOS II, IMPOSTO PB
                                    WHERE IT.CDFILIAL     = SUBSTR(C_TMP.CDCHAVEREG,1,4)
                                      AND IT.NRLANCTONF   = SUBSTR(C_TMP.CDCHAVEREG,5,10)
                                      AND IT.CDPRODUTO    = PR.CDPRODUTO
                                      AND II.CDFILIAL     = IT.CDFILIAL
                                      AND II.NRLANCTONF   = IT.NRLANCTONF
                                      AND II.NRSEQITPROD  = IT.NRSEQITPROD
                                      AND II.CDIMPOSTO    = PB.CDIMPOSTO
                                      AND PB.CDIMPOSTONFE = P_CDIMPOSTO
                                      AND II.NRITPROIMPOS = '1'
                                    ORDER BY IT.NRSEQITPROD ) LOOP

          SELECT RPAD(NVL(MAX(I.CDFISCALIT), '3'), 1, ' ')
            INTO V_CDFISCALIT
            FROM ITEMPROIMPOS I, IMPOSTO P
           WHERE I.CDFILIAL     = C_ARQITENS_MERSERV.CDFILIAL
             AND I.NRLANCTONF   = C_ARQITENS_MERSERV.NRLANCTONF
             AND I.NRLANCTONF   = C_ARQITENS_MERSERV.NRSEQITPROD
             AND I.CDIMPOSTO    = P.CDIMPOSTO
             AND P.CDIMPOSTONFE = '10'
             AND I.NRITPROIMPOS = '1';

          SELECT LPAD(NVL(MAX(CDSITUTRIBITNFE),'49'), 2, ' ')
            INTO V_CDSITUTRIBITNFE
            FROM ITEMPROIMPOS I, IMPOSTO P
           WHERE I.CDFILIAL     = C_ARQITENS_MERSERV.CDFILIAL
             AND I.NRLANCTONF   = C_ARQITENS_MERSERV.NRLANCTONF
             AND I.NRLANCTONF   = C_ARQITENS_MERSERV.NRSEQITPROD
             AND I.CDIMPOSTO    = P.CDIMPOSTO
             AND P.CDIMPOSTONFE = '10'
             AND I.NRITPROIMPOS = '1';

          V_SEQUNCIAL := V_SEQUNCIAL +1;
          INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
          VALUES
            ('03'||LPAD(RTRIM(V_SEQUNCIAL), 8, '0'), C_ARQITENS_MERSERV.PART1||V_CDFISCALIT||C_ARQITENS_MERSERV.PART2||V_CDSITUTRIBITNFE,  P_NRSEQARQMAG);

          /*CODIGO DA NATUREZA - REGISTRO 494*/
          SELECT MAX(CDCHAVEREG)
            INTO V_NATU
            FROM TMP_REGDADOS_IN86
           WHERE CDREGISTRO = '494'
             AND CDCHAVEREG = C_ARQITENS_MERSERV.CDFISOPEITEM;
          IF (V_NATU IS NULL) AND (C_ARQITENS_MERSERV.CDFISOPEITEM IS NOT NULL) THEN
             V_SEQ_NATU := V_SEQ_NATU + 1;
             INSERT INTO TMP_REGDADOS_IN86
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES
               ('494', V_SEQ_NATU, C_ARQITENS_MERSERV.CDFISOPEITEM);
          END IF;

          /*MERCADORIAS/SERVIOS - REGISTRO 495*/
          SELECT MAX(CDCHAVEREG)
            INTO V_PROD
            FROM TMP_REGDADOS_IN86
           WHERE CDREGISTRO = '495'
             AND CDCHAVEREG = C_ARQITENS_MERSERV.CDPRODUTO;
          IF (V_PROD IS NULL) AND (C_ARQITENS_MERSERV.CDPRODUTO IS NOT NULL) THEN
             V_SEQ_PROD := V_SEQ_PROD + 1;
             INSERT INTO TMP_REGDADOS_IN86
               (CDREGISTRO, CDCONTREGI, CDCHAVEREG)
             VALUES
               ('495', V_SEQ_PROD, C_ARQITENS_MERSERV.CDPRODUTO);
          END IF;
      END LOOP;
   END LOOP;

   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQITENS_MERSERV_434','5.33.xxx'); END;
/

