CREATE OR REPLACE PROCEDURE APURAC_EQUIPCLASSEM(
   P_FILIAL    IN FILIAL.CDFILIAL%TYPE,
   P_FILIPROC  IN FILIAL.CDFILIAL%TYPE,
   P_CDCIA     IN COMPANHIA.CDCIA%TYPE,
   P_DTFECHAME IN DATE,
   P_DTINIAPUR IN DATE,
   P_DTFIMAPUR IN DATE,
   P_CDSERIE   IN SERIENF.CDSERIE%TYPE,
   P_IDTPIJURTRAN IN TRANSPORT.IDTPIJURTRAN%TYPE,
   P_NRINSJURTRAN IN TRANSPORT.NRINSJURTRAN%TYPE,
   P_NRAPURACFATM  IN NOTAFISCAL.NRAPURACFATM%TYPE,
   P_GRUPPROD     IN GRUPPROD.CDGRUPPROD%TYPE DEFAULT NULL,
   P_IDGRUPTAXA   IN SERVPLANO.IDTIPSCBOSP%TYPE DEFAULT 'N',
   P_LISTANF      IN VARCHAR DEFAULT NULL,
   P_NRORG IN NUMBER DEFAULT 1)
AS
   V_IDTIPMANUALAP TRAB_APURACM.IDTIPMANUALAP%TYPE;
   V_NRSEQITPROD   NUMBER;

   V_CDCLIENTE     COMPANHIA.CDCLIENTE%TYPE;

   V_NRLANCTONF    VARCHAR(20);

   V_NRLANCTONFAP  VARCHAR(20);

   V_VRCOTDOLAR    TRAB_APURACM.VRCOTDOLARAP%TYPE;
   V_CDCLASSE      TRAB_APURACM.CDCLASSEAP%TYPE;
   V_CDEQUIP       TRAB_APURACM.CDEQUIPAP%TYPE;
   V_CDFISCOPER    TRAB_APURACM.CDFISCOPERAP%TYPE;
   V_IDSERVICO     TRAB_APURACM.IDSERVICOAP%TYPE;
   V_CDSERIE       SERIENF.CDSERIE%TYPE;

   V_CDEMPRESA     FILIAL.CDEMPRESA%TYPE;
   V_CDINSCMUNI    FILIAL.CDINSCMUNI%TYPE;
   V_CDINSCESTA    FILIAL.CDINSCESTA%TYPE;

   V_IDTPIJURCLIE  CLIENTE.IDTPIJURCLIE%TYPE;
   V_NRINSJURCLIE  CLIENTE.NRINSJURCLIE%TYPE;

   V_NOVANOTA      VARCHAR(1);

   V_VRDESCDEL     DELIVERYM.VRDESCDEL%TYPE;
   V_VRDESCSRV     DELIVERYM.VRDESCSRV%TYPE;

   V_VRINDICE      MOVINDICE.VRINDICE%TYPE;
   V_VRUNITITEM    ITEMPRODUTO.VRUNITITEM%TYPE;

   V_IDCONMAXITEM  SERIENF.IDCONMAXITEM%TYPE;
   V_NRMAXITNF     SERIENF.NRMAXITNF%TYPE;
   V_NRMAXSERVNF   SERIENF.NRMAXSERVNF%TYPE;

   V_NRORDEMISPR   TRAB_APURACM.NRORDEMIS%TYPE;
   V_NRORDEMISSV   TRAB_APURACM.NRORDEMIS%TYPE;
   V_NRORDEMIS     TRAB_APURACM.NRORDEMIS%TYPE;

   V_NRCOUNTPR     TRAB_APURACM.NRORDEMIS%TYPE;
   V_NRCOUNTSV     TRAB_APURACM.NRORDEMIS%TYPE;

   V_VRTAXAAERO    ITEMPRODUTO.VRUNITITEM%TYPE;
   V_VRTAXAAEME    ITEMPRODUTO.VRUNITITEM%TYPE;

   V_VRTXAERORAP   TRAB_APURACM.VRTXAERORAP%TYPE;
   V_VRTXAERODAP   TRAB_APURACM.VRTXAERODAP%TYPE;

   V_VRTXTOTRAP     TRAB_APURACM.VRTXAERORAP%TYPE;
   V_VRTXTOTDAP     TRAB_APURACM.VRTXAERODAP%TYPE;
   V_VRSTANDBY      TRAB_APURACM.VRPUDOLSERVAP%TYPE;
   V_VRSTANDBYD     TRAB_APURACM.VRPUDOLSERVAP%TYPE;
   V_QTSTANDBY      SERVPLANO.QTSESBYUTSP%TYPE;
   V_CDPRODTAXA     PRODUTO.CDPRODUTO%TYPE;
   V_NMPRODUTO      PRODUTO.NMPRODUTO%TYPE;
   V_VRTOTANF       NOTAFISCAL.VRNOTAFISC%TYPE;
   V_VRALTXPORT     CIAFILI.VRALTXPORT%TYPE;

   V_IDMUNIUTCONVNFE MUNICIPIO.IDMUNIUTCONVNFE%TYPE;
   V_IDEMPUTILIZANFE PARAMEMPRESA.IDEMPUTILIZANFE%TYPE;

   V_IDPRODSERVAP  TRAB_APURACM.IDPRODSERVAP%TYPE;   

   V_COUNT_SERVICO NUMBER;
   
   V_CDTIPOOPERVENDA VARCHAR2(2);
BEGIN

   SELECT MAX(CDCLIENTE), MAX(CDTIPOOPERVENDA) 
     INTO V_CDCLIENTE, V_CDTIPOOPERVENDA
   FROM COMPANHIA
   WHERE CDCIA = P_CDCIA;
   
   IF V_CDTIPOOPERVENDA IS NULL THEN
      V_CDTIPOOPERVENDA := '01';
   END IF;

   SELECT MAX(CDEMPRESA), MAX(CDINSCMUNI), MAX(CDINSCESTA)
   INTO V_CDEMPRESA, V_CDINSCMUNI, V_CDINSCESTA
   FROM FILIAL
   WHERE CDFILIAL = P_FILIAL;

   SELECT MAX(IDTPIJURCLIE), MAX(NRINSJURCLIE)
   INTO V_IDTPIJURCLIE, V_NRINSJURCLIE
   FROM CLIENTE
   WHERE CDCLIENTE = V_CDCLIENTE;

   SELECT NVL(NRMAXITNF, 10), NVL(NRMAXSERVNF, 5),
          IDCONMAXITEM
   INTO V_NRMAXITNF, V_NRMAXSERVNF, V_IDCONMAXITEM
   FROM SERIENF
   WHERE CDEMPRESA  = V_CDEMPRESA  AND
         CDINSCESTA = V_CDINSCESTA AND
         CDINSCMUNI = V_CDINSCMUNI AND
         CDSERIE    = P_CDSERIE;

  SELECT NVL(MI.IDMUNIUTCONVNFE, 'N') AS IDMUNIUTCONVNFE, NVL(PE.IDEMPUTILIZANFE, 'N') IDEMPUTILIZANFE
    INTO V_IDMUNIUTCONVNFE, V_IDEMPUTILIZANFE
    FROM EMPRESA EP, MUNICIPIO MI, PARAMEMPRESA PE
   WHERE EP.CDEMPRESA = V_CDEMPRESA
     AND EP.CDEMPRESA = PE.CDEMPRESA(+)
     AND EP.CDPAIS = MI.CDPAIS
     AND EP.SGESTADO = MI.SGESTADO
     AND EP.CDMUNICIPIO = MI.CDMUNICIPIO;

   V_NRLANCTONF := 'X';
   V_CDFISCOPER := 'X';
   V_CDCLASSE   := 'X';
   V_CDEQUIP    := 'X';
   V_IDSERVICO  := 'X';
   V_VRCOTDOLAR := -1;

   V_NRSEQITPROD := 0;

   V_NOVANOTA := 'X';

   V_VRDESCDEL := 0;
   V_VRDESCSRV := 0;

   V_NRORDEMISPR := 0;
   V_NRORDEMISSV := V_NRMAXITNF;

   V_NRCOUNTPR   := 0;
   V_NRCOUNTSV   := 0;

   IF ((P_GRUPPROD IS NOT NULL) AND (P_IDGRUPTAXA = 'S')) THEN
      SELECT MAX(AN.CDPRODUTO), MAX(PRODUTO.NMPRODUTO)
      INTO V_CDPRODTAXA, V_NMPRODUTO
      FROM PRSUBGRPROD AN, SUBGRUPPROD SG, GRUPPROD GR, PRODUTO
      WHERE (GR.CDGRUPPROD     = P_GRUPPROD    ) AND
            (GR.CDGRUPPROD     = SG.CDGRUPPROD ) AND
            (SG.CDSUBGRPROD    = AN.CDSUBGRPROD) AND
            (SG.CDGRUPPROD     = AN.CDGRUPPROD ) AND
            (AN.CDFILISUBGR    = 'P'           ) AND
            (PRODUTO.CDPRODUTO = AN.CDPRODUTO  );

      IF (V_CDPRODTAXA IS NULL) THEN
         /*Nao ha Produto para taxa de aeroporto cadastrado no agrupamento informado.*/
         RAISE_APPLICATION_ERROR(-20501, 'APPERRMSGSTR' || 'APP-00051' || 'APPERRMSGEND', TRUE);
      END IF;

      V_VRTXTOTRAP := 0;
      V_VRTXTOTDAP := 0;

      SELECT SUM(N.VRNOTAFISC)
      INTO V_VRTOTANF
      FROM  NOTAFISCAL N
      WHERE N.CDFILIAL      = P_FILIAL                AND
            (INSTR(P_LISTANF, '_'||N.NRLANCTONF) > 0);

      SELECT MAX(VRALTXPORT)
      INTO V_VRALTXPORT
      FROM CIAFILI
      WHERE CDFILIAL = P_FILIAL  AND
            CDCIA    = P_CDCIA;

      V_VRTXTOTRAP := ((NVL(V_VRTOTANF,0) * NVL(V_VRALTXPORT,0))/100);

      IF NVL(V_VRTXTOTRAP,0) > 0 THEN
         NOVO_CODIGO('LANCNF/FILIAL' || P_FILIPROC,V_NRLANCTONF);
        V_NRLANCTONF  := SUBSTR(V_NRLANCTONF, 11, 10);

         V_NRSEQITPROD := 0;

         INSERT INTO NOTAFISCAL
              (CDFILIAL, NRLANCTONF, CDEMPRESA,
             CDINSCESTA, CDINSCMUNI, CDFILIEMIT,
               CDFILIRECE, IDTPIJURNF, NRINSJURNF,
               CDFORNECED, CDCLIENTE, IDERROS, IDAVISOS,
               IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
               NRNOTAFISC, DTENTRSAID,
               VRPRODUTOS, VRNOTAFISC, DTINIAPUFISC,
               DTAPROVACAO, CDOPERAPRO, DTCONTABIL,
               NRPLACAVEIC, SGUFVEIC, IDPGTOFRETE,
               DSQTDEVOLU, DSESPECVOLU, DSMARCAVOLU,
               DSNUMEVOLU, VRPBRUTOVOLU, VRPLIQUVOLU,
               IDENTRSAIDOP, CDTIPOOPER, CDSERIE, IDTPIJURTRAN,
               NRINSJURTRAN, VRTTMOEDESTR, IDSTATUS,
           IDSISTEMA, IDDOCFATUR, NRAPURACFATM, IDORIGDESTNF)
         VALUES
               (P_FILIPROC, V_NRLANCTONF, V_CDEMPRESA,
                V_CDINSCESTA, V_CDINSCMUNI, P_FILIAL,
                 NULL, V_IDTPIJURCLIE, V_NRINSJURCLIE,
               NULL, V_CDCLIENTE, NULL, NULL,
                'N', 'N', 'N',
            ' ', P_DTFECHAME,
               0, 0, P_DTINIAPUR,
                 NULL, NULL, NULL,
                 NULL, NULL, NULL,
               NULL, NULL, NULL,
                 NULL, 0, 0,
                'S', V_CDTIPOOPERVENDA, P_CDSERIE, P_IDTPIJURTRAN,
            P_NRINSJURTRAN, 0, 'P', 'FAC', 'S', P_NRAPURACFATM, 'C');

         V_NRSEQITPROD := V_NRSEQITPROD + 1;


         INSERT INTO ITEMPRODUTO (CDFILIAL, NRLANCTONF, NRSEQITPROD,
                                  CDPRODUTO, CDPRODEMIS,
                                  DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                                  VRUNITITEM, VRDESCITEM,
                                  VRTOTAITEM,
                                  VRCONTITEM, VRBRUTITEM, VRITMOEDESTR,
                                  IDCONFORITEM, IDERROSITEM, IDAVISOSITEM)
         VALUES (P_FILIPROC, V_NRLANCTONF, V_NRSEQITPROD,
                 V_CDPRODTAXA, '1'||V_CDPRODTAXA,
                 V_NMPRODUTO, 'N', 1,
                 V_VRTXTOTRAP, 0,
                 V_VRTXTOTRAP,
                 V_VRTXTOTRAP,
                 V_VRTXTOTRAP,
                 V_VRTXTOTDAP,
                 'N', '00000','00000');
         SELECT MAX(IDTIPMANUALAP)
           INTO V_IDTIPMANUALAP
           FROM TRAB_APURACM
          WHERE CDCIAAP = P_CDCIA
            AND CDFILIALAP = P_FILIPROC
            AND NRAPURACFATAP = P_NRAPURACFATM;

         CALCULA_DESCONTOSM(P_FILIAL, P_FILIPROC,  V_NRLANCTONF, P_CDCIA, P_NRAPURACFATM, P_GRUPPROD);

        APURAC_FECHM(P_FILIAL, P_FILIPROC, V_NRLANCTONF, P_CDCIA, P_DTFECHAME,
                    P_DTINIAPUR, P_DTFIMAPUR);
      END IF;
   ELSE
      FOR CURS_APEQUIPCLASSE IN
         (SELECT CDCIAAP, VRCOTDOLARAP, CDEQUIPAP, CDCLASSEAP, IDTIPMANUALAP, CDFISCOPERAP, CDSUFXCFOPAP,
                 IDSERVICOAP, NRSERVICOCIAFILIAP, CDCICLOAP, CDPRODUTOAP, DSSERVFATUAP, VRPUREASERVAP, VRPUDOLSERVAP,
                 IDPRODSERVAP, QTPROPPRODINIAP, QTPROPPRODFINAP
          FROM TRAB_APURACM
         WHERE CDCIAAP       = P_CDCIA  AND
                CDFILIALAP    = P_FILIPROC AND
                 NRAPURACFATAP = P_NRAPURACFATM 

          GROUP BY CDCIAAP, CDEQUIPAP, CDCLASSEAP, VRCOTDOLARAP, IDTIPMANUALAP, CDFISCOPERAP, CDSUFXCFOPAP,
                  IDSERVICOAP, NRSERVICOCIAFILIAP, CDCICLOAP, CDPRODUTOAP, DSSERVFATUAP, VRPUREASERVAP, VRPUDOLSERVAP,
                   IDPRODSERVAP, QTPROPPRODINIAP, QTPROPPRODFINAP
          ORDER BY CDCIAAP, IDTIPMANUALAP, CDEQUIPAP, CDCLASSEAP, VRCOTDOLARAP, CDFISCOPERAP, CDSUFXCFOPAP,
                   IDSERVICOAP, NRSERVICOCIAFILIAP, CDCICLOAP, CDPRODUTOAP, DSSERVFATUAP, VRPUREASERVAP, VRPUDOLSERVAP,
                   IDPRODSERVAP, QTPROPPRODINIAP, QTPROPPRODFINAP) LOOP

           IF CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S' THEN
              V_NRCOUNTSV := V_NRCOUNTSV + 1;
              IF V_NRCOUNTSV > V_NRMAXSERVNF THEN
                 V_NRORDEMISSV := V_NRORDEMISSV + V_NRMAXITNF + 1;
                 V_NRCOUNTSV   := 1;
              ELSE
                 V_NRORDEMISSV := V_NRORDEMISSV + 1;
              END IF;
              V_NRORDEMIS := V_NRORDEMISSV;
           ELSE
              V_NRCOUNTPR := V_NRCOUNTPR + 1;
              IF V_IDCONMAXITEM <> 'N' THEN
                 IF V_NRCOUNTPR > V_NRMAXITNF THEN
                    V_NRORDEMISPR := V_NRORDEMISPR + V_NRMAXSERVNF + 1;
                    V_NRCOUNTPR   := 1;
                 ELSE
                    V_NRORDEMISPR := V_NRORDEMISPR + 1;
                 END IF;
              ELSE
                 V_NRORDEMISPR := V_NRORDEMISPR + V_NRMAXSERVNF + 1;
                 V_NRCOUNTPR   := 1;
              END IF;
                 V_NRORDEMIS := V_NRORDEMISPR;
           END IF;

           UPDATE TRAB_APURACM
           SET NRORDEMIS = V_NRORDEMIS
           WHERE CDCIAAP               = CURS_APEQUIPCLASSE.CDCIAAP       AND
                 CDFILIALAP            = P_FILIPROC                       AND
                 NRAPURACFATAP         = P_NRAPURACFATM                    AND
                 NRSERVICOCIAFILIAP           = CURS_APEQUIPCLASSE.NRSERVICOCIAFILIAP   AND
                 CDEQUIPAP             = CURS_APEQUIPCLASSE.CDEQUIPAP     AND
                 CDCLASSEAP            = CURS_APEQUIPCLASSE.CDCLASSEAP    AND
                 CDCICLOAP             = CURS_APEQUIPCLASSE.CDCICLOAP     AND
                 CDPRODUTOAP           = CURS_APEQUIPCLASSE.CDPRODUTOAP   AND
                 IDTIPMANUALAP         = CURS_APEQUIPCLASSE.IDTIPMANUALAP AND
                 IDPRODSERVAP          = CURS_APEQUIPCLASSE.IDPRODSERVAP  AND
                 (NVL(CDFISCOPERAP,0)  = NVL(CURS_APEQUIPCLASSE.CDFISCOPERAP,0))  AND
                 (NVL(CDSUFXCFOPAP,0)  = NVL(CURS_APEQUIPCLASSE.CDSUFXCFOPAP,0))  AND
                 (NVL(VRPUREASERVAP,0) = NVL(CURS_APEQUIPCLASSE.VRPUREASERVAP,0)) AND
                 (NVL(VRPUDOLSERVAP,0) = NVL(CURS_APEQUIPCLASSE.VRPUDOLSERVAP,0));
      END LOOP;

      FOR CURS_APEQUIPCLASSE IN
         (SELECT CDCIAAP, VRCOTDOLARAP, CDEQUIPAP, CDCLASSEAP, CDFISCOPERAP, CDSUFXCFOPAP,
                 IDSERVICOAP, NRSERVICOCIAFILIAP, CDCICLOAP, CDPRODUTOAP, DSSERVFATUAP, VRPUREASERVAP, VRPUDOLSERVAP,
                 SUM(NRQTDESERVAP) NRTOTASERVAP,  NVL(SUM(VRDESCDELAP),0) VRDESCDELAP,
                IDTIPMANUALAP, IDPRODSERVAP, NRORDEMIS, QTPROPPRODINIAP, QTPROPPRODFINAP
           FROM TRAB_APURACM
          WHERE CDCIAAP       = P_CDCIA    AND
                 CDFILIALAP    = P_FILIPROC AND
                 NRAPURACFATAP = P_NRAPURACFATM 

           GROUP BY CDCIAAP, CDEQUIPAP, CDCLASSEAP, NRORDEMIS, VRCOTDOLARAP, IDTIPMANUALAP, CDFISCOPERAP, CDSUFXCFOPAP,
                  IDSERVICOAP, NRSERVICOCIAFILIAP, CDCICLOAP, CDPRODUTOAP, DSSERVFATUAP, VRPUREASERVAP, VRPUDOLSERVAP, IDPRODSERVAP,
                    QTPROPPRODINIAP, QTPROPPRODFINAP
           ORDER BY CDCIAAP, IDTIPMANUALAP, CDEQUIPAP, CDCLASSEAP, VRCOTDOLARAP, CDFISCOPERAP, CDSUFXCFOPAP,
                   IDSERVICOAP, NRSERVICOCIAFILIAP, CDCICLOAP, CDPRODUTOAP, DSSERVFATUAP, VRPUREASERVAP, VRPUDOLSERVAP,
                   IDPRODSERVAP, QTPROPPRODINIAP, QTPROPPRODFINAP) LOOP
        
        --Se A DELIVERYM for Nacional 
        IF CURS_APEQUIPCLASSE.IDTIPMANUALAP = '1' THEN
        
            /************************************************************************************************************************
            Gera uma Nova Nota fiscal em um dos casos:

              1. Estiver apurando o primeiro servico (Primeiro dado do Cursor)
              2. For uma nova classe      (Na apuracao por equipamento e classe, laca uma NF para cada equipamento e classe)              
              3. For um  novo equipamento (Na apuracao por equipamento e classe, laca uma NF para cada equipamento e classe)              
              3. For um Produto e tiver alcancado o maximo de Produtos em uma NF, e controlar quantidade maxima de Intens na NF
              4. For um Servico e tiver alcancado o maximo de Servicos em uma NF, e controlar quantidade maxima de Intens na NF
              5. Separa as NFs de Produto e de Servicos quando a empresa utilizar NF-E (Tela Parametros de DFS) e o municipio nao deve
                 da empresa nao deve utilizar convenio de NF-E (campo "Convenio NF-E" da tela "Municipio")
              
         *************************************************************************************************************************/
            IF (CURS_APEQUIPCLASSE.CDFISCOPERAP <> V_CDFISCOPER) OR
               (CURS_APEQUIPCLASSE.CDCLASSEAP   <> V_CDCLASSE)   OR
               (CURS_APEQUIPCLASSE.CDEQUIPAP    <> V_CDEQUIP)    OR
               ((((V_NRCOUNTPR = V_NRMAXITNF)   AND (CURS_APEQUIPCLASSE.IDPRODSERVAP = 'P')) OR
               ((V_NRCOUNTSV = V_NRMAXSERVNF) AND (CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S'))) AND
               (V_IDCONMAXITEM = 'S'))  OR
               ((CURS_APEQUIPCLASSE.IDPRODSERVAP <> V_IDPRODSERVAP) AND (V_IDMUNIUTCONVNFE = 'N') AND
               (V_IDEMPUTILIZANFE = 'S')) THEN


               IF (CURS_APEQUIPCLASSE.CDCLASSEAP <> V_CDCLASSE) OR
                  (CURS_APEQUIPCLASSE.CDEQUIPAP  <> V_CDEQUIP) THEN
                     SELECT NVL(MAX(VRDESCDELAP),0), NVL(MAX(VRDESCSRVAP),0)
                     INTO V_VRDESCDEL, V_VRDESCSRV
                     FROM TRAB_APURACM
                     WHERE (CDCIAAP       = P_CDCIA)                    AND
                           (CDFILIALAP    = P_FILIPROC)                 AND
                           (NRAPURACFATAP = P_NRAPURACFATM)              AND
                           (CURS_APEQUIPCLASSE.CDCLASSEAP = CDCLASSEAP) AND
                           (CURS_APEQUIPCLASSE.CDEQUIPAP  = CDEQUIPAP)  AND
                           ((VRDESCDELAP <> 0) OR (VRDESCSRVAP <> 0));
               END IF;

               V_NOVANOTA  := ' ';
               V_NRCOUNTPR := 0;
               V_NRCOUNTSV := 0;

               /*************************************************
               A pedido da Sky Chefs, quando for uma NF com 
               Servicos, deve conter a Serie 'A'. Portanto,
               a serie de codigo 'A' deve estar cadastrada 
               na tela "Serie de Documentos Fiscais de Saida".
               
               Devido a uma Customizacao nao aprovada, este
               parametro teve que ser passado fixo no codigo,
               a pedido da propria Sky Chefs.
             **************************************************/   
               IF CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S' THEN
                  V_CDSERIE := 'A';
               ELSE
                  V_CDSERIE := P_CDSERIE;
               END IF;

                /* a procedure novo_codigo gera o novo sequencial e tambem
                confirma a inclusao da nota anterior, pois existe um COMMIT
                dentro da novo_codigo */

               NOVO_CODIGO('LANCNF/FILIAL' || P_FILIPROC,V_NRLANCTONF);
               V_NRLANCTONF  := SUBSTR(V_NRLANCTONF, 11, 10);

               V_NRSEQITPROD := 0;

               V_CDFISCOPER  := CURS_APEQUIPCLASSE.CDFISCOPERAP;
               V_CDCLASSE    := CURS_APEQUIPCLASSE.CDCLASSEAP;
               V_CDEQUIP     := CURS_APEQUIPCLASSE.CDEQUIPAP;
               V_IDSERVICO   := CURS_APEQUIPCLASSE.IDSERVICOAP;
               V_IDPRODSERVAP := CURS_APEQUIPCLASSE.IDPRODSERVAP;

               INSERT INTO NOTAFISCAL (CDFILIAL, NRLANCTONF, CDEMPRESA,
                                     CDINSCESTA, CDINSCMUNI, CDFILIEMIT,
                                      CDFILIRECE, IDTPIJURNF, NRINSJURNF,
                                       CDFORNECED, CDCLIENTE, IDERROS, IDAVISOS,
                                       IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
                                       NRNOTAFISC, DTENTRSAID,
                                       VRPRODUTOS, VRNOTAFISC, DTINIAPUFISC,
                                       DTAPROVACAO, CDOPERAPRO, DTCONTABIL,
                                       NRPLACAVEIC, SGUFVEIC, IDPGTOFRETE,
                                       DSQTDEVOLU, DSESPECVOLU, DSMARCAVOLU,
                                       DSNUMEVOLU, VRPBRUTOVOLU, VRPLIQUVOLU,
                                       IDENTRSAIDOP, CDTIPOOPER, CDSERIE, IDTPIJURTRAN,
                                       NRINSJURTRAN, VRTTMOEDESTR, IDSTATUS,
                                       IDSISTEMA, IDDOCFATUR, NRAPURACFATM, IDORIGDESTNF)
             VALUES (P_FILIPROC, V_NRLANCTONF, V_CDEMPRESA,
                       V_CDINSCESTA, V_CDINSCMUNI, P_FILIAL,
                       NULL, V_IDTPIJURCLIE, V_NRINSJURCLIE,
                       NULL, V_CDCLIENTE, NULL, NULL,
                       'N', 'N', 'N',
                       ' ', P_DTFECHAME,
                       0, 0, P_DTINIAPUR,
                       NULL, NULL, NULL,
                       NULL, NULL, NULL,
                       NULL, NULL, NULL,
                     NULL, 0, 0,
                      'S', V_CDTIPOOPERVENDA, V_CDSERIE, P_IDTPIJURTRAN,
                       P_NRINSJURTRAN, 0, 'P', 'FAC', 'S', P_NRAPURACFATM, 'C');
            END IF;

          V_NRSEQITPROD := V_NRSEQITPROD + 1;

            INSERT INTO ITEMPRODUTO (CDFILIAL, NRSEQITPROD,
                                     CDPRODUTO, CDPRODEMIS,
                                     DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                                     VRUNITITEM, VRDESCITEM,
                                     VRTOTAITEM,
                                     VRCONTITEM, VRBRUTITEM, VRITMOEDESTR,
                                     IDCONFORITEM, NRLANCTONF, CDFISOPEITEM,
                                    CDSUFXCFOPPR,
                                     IDERROSITEM, IDAVISOSITEM,
                                     QTPROPPRODINI, QTPROPPRODFIN)
            VALUES (P_FILIPROC, LPAD(TO_CHAR(V_NRSEQITPROD),4,'0'),
                  CURS_APEQUIPCLASSE.CDPRODUTOAP, CURS_APEQUIPCLASSE.IDTIPMANUALAP||CURS_APEQUIPCLASSE.NRSERVICOCIAFILIAP,
                   CURS_APEQUIPCLASSE.DSSERVFATUAP, 'N', CURS_APEQUIPCLASSE.NRTOTASERVAP,
                    CURS_APEQUIPCLASSE.VRPUREASERVAP, 0,
                    ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * CURS_APEQUIPCLASSE.VRPUREASERVAP,2),
                    ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * CURS_APEQUIPCLASSE.VRPUREASERVAP,2),
                    ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * CURS_APEQUIPCLASSE.VRPUREASERVAP,2), 0,
                   'N', V_NRLANCTONF, CURS_APEQUIPCLASSE.CDFISCOPERAP,
                  CURS_APEQUIPCLASSE.CDSUFXCFOPAP, '00000','00000',
                    CURS_APEQUIPCLASSE.QTPROPPRODINIAP, CURS_APEQUIPCLASSE.QTPROPPRODFINAP);

             UPDATE TRAB_APURACM
             SET NRLANCTONFAP = V_NRLANCTONF
             WHERE CDCIAAP = CURS_APEQUIPCLASSE.CDCIAAP       AND
                   CDFILIALAP = P_FILIPROC                         AND
                   NRAPURACFATAP = P_NRAPURACFATM                    AND
                   NRSERVICOCIAFILIAP = CURS_APEQUIPCLASSE.NRSERVICOCIAFILIAP   AND
                   CDCICLOAP = CURS_APEQUIPCLASSE.CDCICLOAP     AND
                   CDEQUIPAP = CURS_APEQUIPCLASSE.CDEQUIPAP     AND
             CDCLASSEAP = CURS_APEQUIPCLASSE.CDCLASSEAP    AND
               CDPRODUTOAP = CURS_APEQUIPCLASSE.CDPRODUTOAP   AND
                   IDTIPMANUALAP = CURS_APEQUIPCLASSE.IDTIPMANUALAP AND
             (NVL(CDFISCOPERAP,0) = NVL(CURS_APEQUIPCLASSE.CDFISCOPERAP,0))  AND
                 (NVL(CDSUFXCFOPAP,0) = NVL(CURS_APEQUIPCLASSE.CDSUFXCFOPAP,0))  AND
                   (NVL(VRPUREASERVAP,0) = NVL(CURS_APEQUIPCLASSE.VRPUREASERVAP,0)) AND
                   NRLANCTONFAP IS NULL;

            IF CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S' THEN
                V_NRCOUNTSV := V_NRCOUNTSV + 1;
            ELSE
              V_NRCOUNTPR := V_NRCOUNTPR + 1;
            END IF;

        --Se A DELIVERYM for Internacional (Faturamento em Dolar) 
        ELSIF CURS_APEQUIPCLASSE.IDTIPMANUALAP = '2' THEN
        
          /*********************************************************************************************************************************
            Gera uma Nova Nota fiscal em um dos casos:
          
              1. Estiver apurando o primeiro servico (Primeiro dado do Cursor)
              2. For uma nova classe      (Na apuracao por equipamento e classe, laca uma NF para cada equipamento e classe)
              3. For um  novo equipamento (Na apuracao por equipamento e classe, laca uma NF para cada equipamento e classe)
              2. A cotacao do dolar mudar de uma linha do cursor para a outra
              3. For um Produto e tiver alcancado o maximo de Produtos em uma NF, e controlar quantidade maxima de Intens na NF
              4. For um Servico e tiver alcancado o maximo de Servicos em uma NF, e controlar quantidade maxima de Intens na NF
              5. Separa as NFs de Produto e de Servicos quando a empresa utilizar NF-E (Tela Parametros de DFS) e o municipio nao deve
                 da empresa nao deve utilizar convenio de NF-E (campo "Convenio NF-E" da tela "Municipio")

         **********************************************************************************************************************************/ 
          IF (CURS_APEQUIPCLASSE.CDFISCOPERAP <> V_CDFISCOPER) OR
               (CURS_APEQUIPCLASSE.CDCLASSEAP   <> V_CDCLASSE)   OR
               (CURS_APEQUIPCLASSE.CDEQUIPAP    <> V_CDEQUIP)    OR
               (CURS_APEQUIPCLASSE.VRCOTDOLARAP <> V_VRCOTDOLAR) OR
               ((((V_NRCOUNTPR = V_NRMAXITNF)   AND (CURS_APEQUIPCLASSE.IDPRODSERVAP = 'P')) OR
               ((V_NRCOUNTSV = V_NRMAXSERVNF) AND (CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S'))) AND
               (V_IDCONMAXITEM = 'S'))  OR
               ((CURS_APEQUIPCLASSE.IDPRODSERVAP <> V_IDPRODSERVAP) AND (V_IDMUNIUTCONVNFE = 'N') AND
               (V_IDEMPUTILIZANFE = 'S')) OR
               ((CURS_APEQUIPCLASSE.IDPRODSERVAP <> V_IDPRODSERVAP) AND (V_IDMUNIUTCONVNFE = 'N') AND
               (V_IDEMPUTILIZANFE = 'S'))  THEN


               IF (CURS_APEQUIPCLASSE.CDCLASSEAP <> V_CDCLASSE) OR
                  (CURS_APEQUIPCLASSE.CDEQUIPAP  <> V_CDEQUIP) THEN
                     SELECT NVL(MAX(VRDESCDELAP),0), NVL(MAX(VRDESCSRVAP),0)
                     INTO V_VRDESCDEL, V_VRDESCSRV
                     FROM TRAB_APURACM
                     WHERE CDCIAAP       = P_CDCIA                     AND
                           CDFILIALAP    = P_FILIPROC                  AND
                          NRAPURACFATAP = P_NRAPURACFATM               AND
                         (CURS_APEQUIPCLASSE.CDCLASSEAP = CDCLASSEAP) AND
                         (CURS_APEQUIPCLASSE.CDEQUIPAP  = CDEQUIPAP)  AND
                         ((VRDESCDELAP <> 0) OR (VRDESCSRVAP <> 0));
               END IF;

             /*************************************************
               A pedido da Sky Chefs, quando for uma NF com 
               Servicos, deve conter a Serie 'A'. Portanto,
               a serie de codigo 'A' deve estar cadastrada
               na tela "Serie de Documentos Fiscais de Saida".
               
               Devido a uma Customizacao nao aprovada, este
               parametro teve que ser passado fixo no codigo,
               a pedido da propria Sky Chefs.
             **************************************************/
               IF CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S' THEN
                  V_CDSERIE := 'A';
               ELSE
                  V_CDSERIE := P_CDSERIE;
               END IF;

               V_NOVANOTA  := ' ';
               V_NRCOUNTPR := 0;
               V_NRCOUNTSV := 0;
               /* a procedure novo_codigo gera o novo sequencial e tambem
                  confirma a inclusao da nota anterior, pois existe um COMMIT
                 dentro da novo_codigo */

               NOVO_CODIGO('LANCNF/FILIAL' || P_FILIPROC,V_NRLANCTONF);
                           V_NRLANCTONF  := SUBSTR(V_NRLANCTONF, 11, 10);

               V_NRSEQITPROD := 0;

               V_CDFISCOPER  := CURS_APEQUIPCLASSE.CDFISCOPERAP;
               V_CDCLASSE    := CURS_APEQUIPCLASSE.CDCLASSEAP;
               V_CDEQUIP     := CURS_APEQUIPCLASSE.CDEQUIPAP;
               V_VRCOTDOLAR  := CURS_APEQUIPCLASSE.VRCOTDOLARAP;
               V_IDSERVICO   := CURS_APEQUIPCLASSE.IDSERVICOAP;
               V_IDPRODSERVAP := CURS_APEQUIPCLASSE.IDPRODSERVAP;

               INSERT INTO NOTAFISCAL (CDFILIAL, NRLANCTONF, CDEMPRESA,
                                      CDINSCESTA, CDINSCMUNI, CDFILIEMIT,
                                      CDFILIRECE, IDTPIJURNF, NRINSJURNF,
                                      CDFORNECED, CDCLIENTE, IDERROS, IDAVISOS,
                                      IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
                                      NRNOTAFISC, DTENTRSAID,
                                      VRPRODUTOS, VRNOTAFISC, DTINIAPUFISC,
                                      DTAPROVACAO, CDOPERAPRO, DTCONTABIL,
                                      NRPLACAVEIC, SGUFVEIC, IDPGTOFRETE,
                                      DSQTDEVOLU, DSESPECVOLU, DSMARCAVOLU,
                                      DSNUMEVOLU, VRPBRUTOVOLU, VRPLIQUVOLU,
                                      IDENTRSAIDOP, CDTIPOOPER, CDSERIE, IDTPIJURTRAN,
                                      NRINSJURTRAN, VRTTMOEDESTR, IDSTATUS,
                                      IDSISTEMA, IDDOCFATUR, NRAPURACFATM, IDORIGDESTNF)
                     VALUES (P_FILIPROC, V_NRLANCTONF, V_CDEMPRESA,
                             V_CDINSCESTA, V_CDINSCMUNI, P_FILIAL,
                             NULL, V_IDTPIJURCLIE, V_NRINSJURCLIE,
                             NULL, V_CDCLIENTE, NULL, NULL,
                             'N', 'N', 'N',
                             ' ', P_DTFECHAME,
                             0, 0, P_DTINIAPUR,
                             NULL, NULL, NULL,
                             NULL, NULL, NULL,
                             NULL, NULL, NULL,
                             NULL, 0, 0,
                             'S', V_CDTIPOOPERVENDA, V_CDSERIE, P_IDTPIJURTRAN,
                             P_NRINSJURTRAN, 0, 'P', 'FAC', 'S', P_NRAPURACFATM, 'C');
            END IF;

        V_NRSEQITPROD := V_NRSEQITPROD + 1;

            V_VRINDICE := CURS_APEQUIPCLASSE.VRCOTDOLARAP;

            IF V_VRINDICE IS NULL THEN
             RAISE_APPLICATION_ERROR(-20501, 'APPERRMSGSTR' || 'APP-00034' || 'APPERRMSGEND', TRUE);
            END IF;

            V_VRUNITITEM := CURS_APEQUIPCLASSE.VRPUDOLSERVAP * V_VRINDICE;

           INSERT INTO ITEMPRODUTO (CDFILIAL,      NRSEQITPROD,
                                     CDPRODUTO,     CDPRODEMIS,
                                    DSPRODEMIS,    IDATUVRESTOQ,
                                     QTITEMPROD,    VRUNITITEM,   VRDESCITEM,
                                    VRTOTAITEM,    VRCONTITEM,   VRBRUTITEM,
                                     VRITMOEDESTR,  IDCONFORITEM, NRLANCTONF,
                                     CDFISOPEITEM,  CDSUFXCFOPPR, IDERROSITEM,
                                     IDAVISOSITEM,  QTPROPPRODINI, QTPROPPRODFIN)
                  VALUES (P_FILIPROC, LPAD(TO_CHAR(V_NRSEQITPROD),4,'0'),
                          CURS_APEQUIPCLASSE.CDPRODUTOAP, CURS_APEQUIPCLASSE.IDTIPMANUALAP||CURS_APEQUIPCLASSE.NRSERVICOCIAFILIAP,
                          CURS_APEQUIPCLASSE.DSSERVFATUAP, 'N', CURS_APEQUIPCLASSE.NRTOTASERVAP,
                          V_VRUNITITEM, 0,
                          ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * V_VRUNITITEM,2),
                          ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * V_VRUNITITEM,2),
                          ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * V_VRUNITITEM,2),
                          ROUND(CURS_APEQUIPCLASSE.NRTOTASERVAP * CURS_APEQUIPCLASSE.VRPUDOLSERVAP,2),
                          'N', V_NRLANCTONF, CURS_APEQUIPCLASSE.CDFISCOPERAP,
                          CURS_APEQUIPCLASSE.CDSUFXCFOPAP, '00000','00000',
                          CURS_APEQUIPCLASSE.QTPROPPRODINIAP, CURS_APEQUIPCLASSE.QTPROPPRODFINAP);

     UPDATE TRAB_APURACM
          SET NRLANCTONFAP = V_NRLANCTONF
            WHERE CDCIAAP         = CURS_APEQUIPCLASSE.CDCIAAP      AND
                  CDFILIALAP     = P_FILIPROC                       AND
                  NRAPURACFATAP  = P_NRAPURACFATM                    AND
                  NRSERVICOCIAFILIAP    = CURS_APEQUIPCLASSE.NRSERVICOCIAFILIAP   AND
                  CDCICLOAP = CURS_APEQUIPCLASSE.CDCICLOAP     AND
            CDEQUIPAP      = CURS_APEQUIPCLASSE.CDEQUIPAP     AND
              CDCLASSEAP     = CURS_APEQUIPCLASSE.CDCLASSEAP    AND
                  CDPRODUTOAP    = CURS_APEQUIPCLASSE.CDPRODUTOAP   AND
            IDTIPMANUALAP  = CURS_APEQUIPCLASSE.IDTIPMANUALAP AND
                (NVL(VRCOTDOLARAP,0)  = NVL(CURS_APEQUIPCLASSE.VRCOTDOLARAP,0))  AND
                  (NVL(CDFISCOPERAP,0)  = NVL(CURS_APEQUIPCLASSE.CDFISCOPERAP,0))  AND
                  (NVL(CDSUFXCFOPAP,0)  = NVL(CURS_APEQUIPCLASSE.CDSUFXCFOPAP,0))  AND
              (NVL(VRPUDOLSERVAP,0) = NVL(CURS_APEQUIPCLASSE.VRPUDOLSERVAP,0)) AND
                  NRLANCTONFAP IS NULL;

            IF CURS_APEQUIPCLASSE.IDPRODSERVAP = 'S' THEN
               V_NRCOUNTSV := V_NRCOUNTSV + 1;
            ELSE
               V_NRCOUNTPR := V_NRCOUNTPR + 1;
            END IF;
         END IF;
      END LOOP;

      /* RETORNA VALOR DA TAXA POR VOO E TRECHO*/
      FOR C_TAXAAEROPORTO IN
        (SELECT CDCIAAP, CDEQUIPAP, CDCLASSEAP, IDTIPMANUALAP, SUM(NVL(VRTXAERORAP, 0)) AS VRTXAERORAP, SUM(NVL(VRTXAERODAP, 0)) AS VRTXAERODAP
           FROM TRAB_APURACM
          WHERE CDCIAAP = P_CDCIA
            AND CDFILIALAP = P_FILIPROC
            AND NRAPURACFATAP = P_NRAPURACFATM
          GROUP BY CDCIAAP, CDEQUIPAP, CDCLASSEAP, IDTIPMANUALAP) LOOP

        /*-----------------------------------------------
           Dentre as NFs geradas durante a apuracao,
           busca a mais recente que contiver "Servicos"
           (Handling, por exemplo).
        -----------------------------------------------*/
         SELECT COUNT(1)
         INTO V_COUNT_SERVICO
           FROM TRAB_APURACM
          WHERE CDCIAAP = C_TAXAAEROPORTO.CDCIAAP
            AND CDEQUIPAP = C_TAXAAEROPORTO.CDEQUIPAP
            AND CDCLASSEAP = C_TAXAAEROPORTO.CDCLASSEAP
            AND NRAPURACFATAP = P_NRAPURACFATM
            AND IDPRODSERVAP = 'S';

       /*************************************************************************
         se V_NRLANCTONFAP estiver vazio, nao foi gerada nenhuma NF com servicos,
         portanto uma nova NF de vservicos deve ser criada para a inclusao da
         taxa de aeroporto.
       **************************************************************************/
         IF (V_COUNT_SERVICO > 0) THEN

            NOVO_CODIGO('LANCNF/FILIAL' || P_FILIPROC,V_NRLANCTONF);
            V_NRLANCTONF  := SUBSTR(V_NRLANCTONF, 11, 10);

            INSERT INTO NOTAFISCAL (CDFILIAL, NRLANCTONF, CDEMPRESA,
                                    CDINSCESTA, CDINSCMUNI, CDFILIEMIT,
                                    CDFILIRECE, IDTPIJURNF, NRINSJURNF,
                                    CDFORNECED, CDCLIENTE, IDERROS, IDAVISOS,
                                    IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
                                    NRNOTAFISC, DTENTRSAID,
                                    VRPRODUTOS, VRNOTAFISC, DTINIAPUFISC,
                                    DTAPROVACAO, CDOPERAPRO, DTCONTABIL,
                                    NRPLACAVEIC, SGUFVEIC, IDPGTOFRETE,
                                    DSQTDEVOLU, DSESPECVOLU, DSMARCAVOLU,
                                    DSNUMEVOLU, VRPBRUTOVOLU, VRPLIQUVOLU,
                                    IDENTRSAIDOP, CDTIPOOPER, CDSERIE, IDTPIJURTRAN,
                                    NRINSJURTRAN, VRTTMOEDESTR, IDSTATUS,
                                    IDSISTEMA, IDDOCFATUR, NRAPURACFATM, IDORIGDESTNF)
            VALUES (P_FILIPROC, V_NRLANCTONF, V_CDEMPRESA,
                    V_CDINSCESTA, V_CDINSCMUNI, P_FILIAL,
                    NULL, V_IDTPIJURCLIE, V_NRINSJURCLIE,
                    NULL, V_CDCLIENTE, NULL, NULL,
                    'N', 'N', 'N',
                    ' ', P_DTFECHAME,
                    0, 0, P_DTINIAPUR,
                    NULL, NULL, NULL,
                    NULL, NULL, NULL,
                    NULL, NULL, NULL,
                    NULL, 0, 0,
                    'S', V_CDTIPOOPERVENDA, 'A', P_IDTPIJURTRAN,
                    P_NRINSJURTRAN, 0, 'P', 'FAC', 'S', P_NRAPURACFATM, 'C');

            --Calcula a Taxa de Aeroporto na nova Nota Fiscal de Servicos
            CALCULA_TAXAAEROPORTO(P_FILIAL, P_FILIPROC, V_NRLANCTONF, C_TAXAAEROPORTO.IDTIPMANUALAP, C_TAXAAEROPORTO.VRTXAERORAP, C_TAXAAEROPORTO.VRTXAERODAP);

            APURAC_DADOSADICM(P_FILIAL, P_FILIPROC, V_NRLANCTONF, P_CDCIA, 'T', 'T',C_TAXAAEROPORTO.CDCLASSEAP,NULL,C_TAXAAEROPORTO.CDEQUIPAP,'T','T');

        /*************************************************************************
          se V_NRLANCTONFAP nao estiver vazio, o mesmo contem a NF mais recente,
          dentre as geradas nesta Apuracao, que contenha servicos. Nesta
          NF sera incluida a Taxa de Aeroporto.
        **************************************************************************/
         ELSE
            SELECT MAX(NRLANCTONFAP)
              INTO V_NRLANCTONFAP
            FROM TRAB_APURACM
            WHERE CDCIAAP = C_TAXAAEROPORTO.CDCIAAP
              AND CDEQUIPAP = C_TAXAAEROPORTO.CDEQUIPAP
              AND CDCLASSEAP = C_TAXAAEROPORTO.CDCLASSEAP
              AND NRAPURACFATAP = P_NRAPURACFATM
              AND IDPRODSERVAP = 'P';
            IF (V_NRLANCTONFAP  IS not NULL) THEN
               --Calcula a Taxa de Aeroporto na NF de servicos atual
               CALCULA_TAXAAEROPORTO(P_FILIAL, P_FILIPROC, V_NRLANCTONFAP, C_TAXAAEROPORTO.IDTIPMANUALAP,C_TAXAAEROPORTO.VRTXAERORAP, C_TAXAAEROPORTO.VRTXAERODAP);

            END IF;
         END IF;
      END LOOP;

      FOR C_CALCULANOTAPROD IN
         (SELECT NRLANCTONF
            FROM NOTAFISCAL
          WHERE CDFILIAL = P_FILIPROC
            AND NRAPURACFATM = P_NRAPURACFATM) LOOP

         CALCULA_DESCONTOSM(P_FILIAL, P_FILIPROC, C_CALCULANOTAPROD.NRLANCTONF, P_CDCIA, P_NRAPURACFATM);

         APURAC_FECHM(P_FILIAL, P_FILIPROC, C_CALCULANOTAPROD.NRLANCTONF, P_CDCIA, P_DTFECHAME, P_DTINIAPUR,P_DTFIMAPUR);

      END LOOP;
   END IF;
END;
/